/**
 * @jsx React.DOM
 */

var React = require('react'),
  mui = require('mui'),
  PaperButton = mui.PaperButton,
  CodeExample = require('../../code-example/code-example.jsx'),
  ComponentInfo = require('../../component-info.jsx');

var ButtonPage = React.createClass({

  render: function() {
    var code = 
      '//Flat Buttons\n' +
      '<PaperButton type="FLAT" label="Default" />\n' +
      '<PaperButton type="FLAT" label="Primary" primary={true} />\n' +
      '<PaperButton type="FLAT" label="Disabled" disabled={true} />\n\n' +
      '//Raised Buttons\n' + 
      '<PaperButton type="RAISED" label="Default" />\n' +
      '<PaperButton type="RAISED" label="Primary" primary={true} />\n' +
      '<PaperButton type="RAISED" label="Disabled" disabled={true} />\n\n' +
      '//Floating Action Buttons\n' +
      '<PaperButton type="FAB_MINI" icon="star" />\n' +
      '<PaperButton type="FAB" icon="star" />';

    return (
    	<div>

    		<h2 className="mui-font-style-headline">Buttons</h2>
        <CodeExample code={code}>

          <div className="button-examples">

            <div className="button-examples-row">
              <PaperButton type="FLAT" label="Default" onClick={this._onPaperButtonClick} />
              <PaperButton type="FLAT" label="Primary" primary={true} onClick={this._onPaperButtonClick} />
              <PaperButton type="FLAT" label="Disabled" disabled={true} />
            </div>

            <div className="button-examples-row">
              <PaperButton type="RAISED" label="Default" onClick={this._onPaperButtonClick} />
              <PaperButton type="RAISED" label="Primary" primary={true} onClick={this._onPaperButtonClick} />
              <PaperButton type="RAISED" label="Disabled" disabled={true} />
            </div>

            <div className="button-examples-row">
              <PaperButton type="FAB_MINI"icon="star" onClick={this._onPaperButtonClick} />
              <PaperButton type="FAB" icon="star" onClick={this._onPaperButtonClick} />
            </div>

          </div>

        </CodeExample>

        <h3 className="mui-font-style-title">Props</h3>
        {this._getPropInfo()}

    	</div>
    );
  },

  _getPropInfo: function() {
    var info = [
          {
            name: 'disabled',
            type: 'bool',
            header: 'default: false',
            desc: 'Indicates that the button is disabled or not.'
          },
          {
            name: 'href',
            type: 'string',
            header: 'optional',
            desc: 'This is the href on the anchor tag generated by this component.'
          },
          {
            name: 'icon',
            type: 'string',
            header: 'optional',
            desc: 'This is the name of the icon to display inside the button. This only applies to ' +
              'floating action buttons.'
          },
          {
            name: 'label',
            type: 'string',
            header: 'optional',
            desc: 'This is the text to display inside the button. This only applies to flat and ' +
              'raised buttons.'
          },
          {
            name: 'primary',
            type: 'bool',
            header: 'default: false',
            desc: 'If true, the button will use the primary app color as the button color.'
          },
          {
            name: 'type',
            type: 'oneOf [RAISED, FLAT, FAB, FAB_MINI]',
            header: 'default: RAISED',
            desc: 'This indicates what type of button to render.'
          }
        ];

    return <ComponentInfo infoArray={info} />;
  },

});

module.exports = ButtonPage;
